
#include <stdlib.h>
#include <stdio.h>
#include <cstring>
#include <map>
#include <zlib.h>
#include "bambi_interface.h"
#ifndef _types_t
#define _types_t
typedef short unsigned int suint;

#define LENS 10000


// struct for covar class - classy


typedef struct{
  int nInd;//number of inds inferred from filelists
  int argc;
  char **argv;
  int inputtype;
  int *usedArgs; //array of ints telling if args been used
  FILE *argumentFile; //logfile
  const char *outfiles; //prefix output
}argStruct;



extern int refToInt[256];
extern char intToRef[5];

struct ltstr
{
  bool operator()(const char* s1, const char* s2) const
  {
    return strcmp(s1, s2) < 0;
  }
};

typedef struct {
  char * chromo;
  int position;
}loci;


typedef struct{
  double *pml; 
  double *pmlun;
  double *pEM; 
  double *pEMun; 
  double *pmlSNP; 
  double *pmlunSNP;
  double *pEMSNP; 
  double *pEMunSNP;
  int *keepInd; 
}funkyPrintFreq;

typedef struct{

  double **stat;
  int **keepInd;
  double *freq;
  double *lrt_snp;
  int *highHe;
  int *highHo;
}funkyPrintAsso;


typedef struct {
  funkyPrintFreq *freq;
  funkyPrintAsso *asso;
  
}funkyPrint;


typedef struct {
  //dynamic
  loci *sites;
  suint **counts;//[nsites][5xiNind] !!!! nope! only 4
  double **likes;
  double **post;
  double *phat;
  double **errors;
  int *major;
  int *minor;
  char *ref;
  char *anc;

  //primitives
  int numSites;
  int nInd;
  int **depth;

  //for print
  funkyPrint *results;

  //sites removed in analysis and print
  int *keepSites;
  int chunkNumber;
  
  //stuff needed for bamreader
  fcb *for_callback;
  chunkyT *chk;
  int killSig;
  
  //extra stuff associated with each analysis module
  void **extras;
  
}funkyPars;

funkyPars *allocFunkyPars();
void deallocFunkyPars(funkyPars *p);


void init(argStruct *arguments);//intialize all needed objects
void destroy();//destroy all initialized objects
void selector(funkyPars *p);

size_t fsize(const char* fname);
int fexists(const char* str);//{///@param str Filename given as a string.
FILE *openFile(const char* a,const char* b);
gzFile openFileGz(const char* a,const char* b,const char *mode);
FILE *getFILE(const char*fname,const char* mode);
gzFile getGz(const char*fname,const char* mode);

#define LOGMAX 20000   // pre-computed logfactorial 
#endif
